#include<bits/stdc++.h>
using namespace std;
#define mp make_pair
#define pb push_back
#define st first
#define nd second
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
#define maxn 4005
#define inf 1000000000

int n, m, E, res;
int in[maxn], out[maxn];
vector<int> v[maxn];
int cap[maxn][maxn];
int cur[maxn];
int dis[maxn];

queue<int> q;
void bfs(){
    fill(cur, cur+2*n+2, 0);
    fill(dis, dis+2*n+2, -1);
    dis[0]=0;
    q.push(0);
    while(!q.empty()){
        int w=q.front();
        q.pop();
        for(int i=0; i<v[w].size(); i++){
            int u=v[w][i];
            if(dis[u]==-1 && cap[w][u]>0){
                dis[u]=dis[w]+1;
                q.push(u);
            }
        }
    }
}

int dfs(int w, int flow){
    if(flow==0) return 0;
    if(w==E){
        res+=flow;
        return flow;
    }
    int RES=0;
    for(int i=cur[w]; i<v[w].size(); i++){
        if(flow==0) break;
        else cur[w]=i;
        int u=v[w][i];
        if(dis[u]==dis[w]+1){
            int e=dfs(u, min(flow, cap[w][u]));
            flow-=e;
            RES+=e;
            cap[w][u]-=e;
            cap[u][w]+=e;
        }
    }
    return RES;
}

int main(){
    scanf("%d%d", &n, &m);
    E=2*n+1;
    for(int i=1; i<=m; i++){
        int a, b;
        scanf("%d%d", &a, &b);
        v[b].pb(a+n);
        v[a+n].pb(b);
        cap[b][a+n]=1;
        in[b]++;
        out[a]++;
    }
    for(int i=1; i<=n; i++){
        v[0].pb(i);
        v[i].pb(0);
        v[2*n+1].pb(n+i);
        cap[0][i]=max(0, in[i]-1);
        v[n+i].pb(2*n+1);
        cap[n+i][2*n+1]=max(0, out[i]-1);
    }
   // cout<<cap[4][6]<<" "<<cap[5][6]<<" ";
    while(1){
        bfs();
        if(dfs(0, inf)==0) break;
    }
    printf("%d\n", res);

}
